import { Request, Response, NextFunction } from 'express';
export declare enum RequestType {
    GET = "GET",
    POST = "POST",
    PUT = "PUT",
    DELETE = "DELETE",
    PATCH = "PATCH"
}
export interface IExpressHandler {
    (req: any, res: any): any;
}
export interface ParserOptions {
    enableCors?: boolean;
    buildReactive?: boolean;
    buildEndpoints?: boolean;
    groupByFolder?: boolean;
}
export declare type EndpointMiddleware = (req: Request, res: Response, next: NextFunction) => any;
export interface EndpointOptions {
    enableCors?: boolean;
    enableFileUpload?: boolean;
    middlewares?: EndpointMiddleware[];
}
export declare class Endpoint {
    name: string | undefined;
    requestType: RequestType;
    handler: IExpressHandler;
    options?: EndpointOptions | undefined;
    constructor(name: string | undefined, requestType: RequestType, handler: IExpressHandler, options?: EndpointOptions | undefined);
}
export declare class Get extends Endpoint {
    constructor(handler: IExpressHandler, options?: EndpointOptions);
}
export declare class Post extends Endpoint {
    constructor(handler: IExpressHandler, options?: EndpointOptions);
}
export declare class Put extends Endpoint {
    constructor(handler: IExpressHandler, options?: EndpointOptions);
}
export declare class Delete extends Endpoint {
    constructor(handler: IExpressHandler, options?: EndpointOptions);
}
export declare class Patch extends Endpoint {
    constructor(handler: IExpressHandler, options?: EndpointOptions);
}
